/**
 * Controller containing a wealth of single-fetched information.
 * All unset- functions remove the single-fetched information entry, allowing things to be fetched once more.
 * 
 * Capabilities:
 * -gold
 * -strip
 * -pants (wearPants, removePants)
 * -bra (wearBra, removeBra)
 * -shirt (wearShirt, removeShirt)
 * -underwear (wearUnderwear, removeUnderwear)
 * -helmet (wearHelmet, removeHelmet)
 * -shoes (wearShoes, removeShoes)
 * -weapon (wearWeapon, removeWeapon)
 * 
 * -nude
 * -importantNude
 * -groinExposed
 * -chestExposed
 * -crossdressing
 * 
 * -gender
 * -baseGender
 * -dick
 * -dickVirgin
 * -cockslitVirgin
 * -cunt
 * -cuntVirgin
 * -analVirgin
 * -boobs
 * -lactating
 * -name
 * 
 * -health
 * -unsetHealth
 * -sanity
 * -unsetSanity
 * -stamina
 * -unsetStamina
 * -exertion
 * -unsetExertion
 * 
 * -agility
 * -unsetAgility
 * -charisma
 * -unsetCharisma
 * -endurance
 * -unsetEndurance
 * -intelligence
 * -unsetIntelligence
 * -luck
 * -unsetLuck
 * -strength
 * -unsetStrength
 * -unsetAll
 * 
 * @param {string} id id of the scene using this controller.
 * @param {string} key Controller-specific key. Default empty string.
 * @param {string} separator Separator between key and function-key.
 */
function MiscController(id, key, separator) {
    var that = this;
    key = key || "";
    separator = separator || "";

    this.gold = function () {
        var goldId = key + separator + "gold";
        global.kobold.history.setIfNotSet(id, goldId, global.kobold.inventory.coins);
        return global.kobold.history.getKey(id, goldId);
    };

    this.strip = function () {
        var stripId = key + separator + "strip";
        global.kobold.history.doIfNotSet(id, stripId, true, function () {
            global.kobold.inventory.equipment.stripNaked();
        });
    };

    this.pants = function () {
        var pantsId = key + separator + "pants";
        global.kobold.history.setIfNotSet(id, pantsId, global.kobold.inventory.equipment.pants);
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, pantsId));
    };

    this.wearPants = function (bottom) {
        var pantsId = key + separator + "wearPants";
        global.kobold.history.doIfNotSet(id, pantsId, true, function () {
            global.kobold.inventory.equipment.wear(bottom);
        });
    };

    this.removePants = function () {
        var pantsId = key + separator + "removePants";
        global.kobold.history.doIfNotSet(id, pantsId, true, function () {
            global.kobold.inventory.equipment.strip(SlotEnum.PANTS);
        });
    };

    this.bra = function () {
        var braId = key + separator + "bra";
        global.kobold.history.setIfNotSet(id, braId, global.kobold.inventory.equipment.bra);
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, braId));
    };

    this.wearBra = function (top) {
        var braId = key + separator + "wearBra";
        global.kobold.history.doIfNotSet(id, braId, true, function () {
            global.kobold.inventory.equipment.wear(top);
        });
    };

    this.removeBra = function () {
        var braId = key + separator + "removeBra";
        global.kobold.history.doIfNotSet(id, braId, true, function () {
            global.kobold.inventory.equipment.strip(SlotEnum.BRA);
        });
    };

    this.shirt = function () {
        var shirtId = key + separator + "shirt";
        global.kobold.history.setIfNotSet(id, shirtId, global.kobold.inventory.equipment.shirt);
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, shirtId));
    };

    this.wearShirt = function (top) {
        var shirtId = key + separator + "wearShirt";
        global.kobold.history.doIfNotSet(id, shirtId, true, function () {
            global.kobold.inventory.equipment.wear(top);
        });
    };

    this.removeShirt = function () {
        var shirtId = key + separator + "removeShirt";
        global.kobold.history.doIfNotSet(id, shirtId, true, function () {
            global.kobold.inventory.equipment.strip(SlotEnum.SHIRT);
        });
    };

    this.underwear = function () {
        var underwearId = key + separator + "underwear";
        global.kobold.history.setIfNotSet(id, underwearId, global.kobold.inventory.equipment.underwear);
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, underwearId));
    };

    this.wearUnderwear = function (undies) {
        var underwearId = key + separator + "wearUnderwear";
        global.kobold.history.doIfNotSet(id, underwearId, true, function () {
            global.kobold.inventory.equipment.wear(undies);
        });
    };

    this.removeUnderwear = function () {
        var underwearId = key + separator + "removeUnderwear";
        global.kobold.history.doIfNotSet(id, underwearId, true, function () {
            global.kobold.inventory.equipment.strip(SlotEnum.UNDERWEAR);
        });
    };

    this.helmet = function () {
        var helmetId = key + separator + "helmet";
        global.kobold.history.setIfNotSet(id, helmetId, global.kobold.inventory.equipment.helmet);
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, helmetId));
    };

    this.wearHelmet = function (helm) {
        var helmetId = key + separator + "wearHelmet";
        global.kobold.history.doIfNotSet(id, helmetId, true, function () {
            global.kobold.inventory.equipment.wear(helm);
        });
    };

    this.removeHelmet = function () {
        var helmetId = key + separator + "removeHelmet";
        global.kobold.history.doIfNotSet(id, helmetId, true, function () {
            global.kobold.inventory.equipment.strip(SlotEnum.HELMET);
        });
    };

    this.shoes = function () {
        var shoesId = key + separator + "shoes";
        global.kobold.history.setIfNotSet(id, shoesId, global.kobold.inventory.equipment.shoes);
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, shoesId));
    };

    this.wearShoes = function (footwear) {
        var shoesId = key + separator + "wearShoes";
        global.kobold.history.doIfNotSet(id, shoesId, true, function () {
            global.kobold.inventory.equipment.wear(footwear);
        });
    };

    this.removeShoes = function () {
        var shoesId = key + separator + "removeShoes";
        global.kobold.history.doIfNotSet(id, shoesId, true, function () {
            global.kobold.inventory.equipment.strip(SlotEnum.SHOES);
        });
    };

    this.weapon = function () {
        var weaponId = key + separator + "weapon";
        global.kobold.history.setIfNotSet(id, weaponId, global.kobold.inventory.equipment.weapon);
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, weaponId));
    };

    this.wearWeapon = function (weapon) {
        var weaponId = key + separator + "wearWeapon";
        global.kobold.history.doIfNotSet(id, weaponId, true, function () {
            global.kobold.inventory.equipment.wear(weapon);
        });
    };

    this.removeWeapon = function () {
        var weaponId = key + separator + "removeWeapon";
        global.kobold.history.doIfNotSet(id, weaponId, true, function () {
            global.kobold.inventory.equipment.strip(SlotEnum.WEAPON);
        });
    };


    this.nude = function () {
        var nudeId = key + separator + "nude";
        global.kobold.history.setIfNotSet(id, nudeId, global.kobold.inventory.equipment.completelyNaked());
        return global.kobold.history.getKey(id, nudeId);
    };

    this.importantNude = function () {
        var importantNudeId = key + separator + "importantNude";
        global.kobold.history.setIfNotSet(id, importantNudeId, global.kobold.inventory.equipment.importantNaked());
        return global.kobold.history.getKey(id, importantNudeId);
    };

    this.groinExposed = function () {
        var groinExposedId = key + separator + "groinExposed";
        global.kobold.history.setIfNotSet(id, groinExposedId, global.kobold.inventory.equipment.groinExposed());
        return global.kobold.history.getKey(id, groinExposedId);
    };

    this.chestExposed = function () {
        var chestExposedId = key + separator + "chestExposed";
        global.kobold.history.setIfNotSet(id, chestExposedId, global.kobold.inventory.equipment.chestExposed());
        return global.kobold.history.getKey(id, chestExposedId);
    };

    this.crossdressing = function () {
        var crossdressingId = key + separator + "crossdressing";
        global.kobold.history.setIfNotSet(id, crossdressingId, global.kobold.inventory.equipment.isCrossdressing());
        return global.kobold.history.getKey(id, crossdressingId);
    };


    this.gender = function () {
        var genderId = key + separator + "gender";
        global.kobold.history.setIfNotSet(id, genderId, global.kobold.body.gender);
        return global.kobold.history.getKey(id, genderId);
    };

    this.baseGender = function () {
        var baseGenderId = key + separator + "baseGender";
        global.kobold.history.setIfNotSet(id, baseGenderId, global.kobold.body.getBaseGender());
        return global.kobold.history.getKey(id, baseGenderId);
    };

    this.dick = function () {
        var dickId = key + separator + "dick";
        global.kobold.history.setIfNotSet(id, dickId, global.kobold.body.dick);
        return global.kobold.history.getKey(id, dickId);
    };

    this.dickVirgin = function () {
        var dickVirginId = key + separator + "dickVirgin";
        global.kobold.history.setIfNotSet(id, dickVirginId, global.kobold.body.dickVirgin);
        return global.kobold.history.getKey(id, dickVirginId);
    };

    this.cockslitVirgin = function () {
        var cockslitVirginId = key + separator + "cockslitVirgin";
        global.kobold.history.setIfNotSet(id, cockslitVirginId, global.kobold.body.cockslitVirgin);
        return global.kobold.history.getKey(id, cockslitVirginId);
    };

    this.cunt = function () {
        var cuntId = key + separator + "cunt";
        global.kobold.history.setIfNotSet(id, cuntId, global.kobold.body.cunt);
        return global.kobold.history.getKey(id, cuntId);
    };

    this.cuntVirgin = function () {
        var cuntVirginId = key + separator + "cuntVirgin";
        global.kobold.history.setIfNotSet(id, cuntVirginId, global.kobold.body.vaginalVirgin);
        return global.kobold.history.getKey(id, cuntVirginId);
    };

    this.analVirgin = function () {
        var analVirginId = key + separator + "analVirgin";
        global.kobold.history.setIfNotSet(id, analVirginId, global.kobold.body.analVirgin);
        return global.kobold.history.getKey(id, analVirginId);
    };

    this.boobs = function () {
        var boobsId = key + separator + "boobs";
        global.kobold.history.setIfNotSet(id, boobsId, global.kobold.body.breasts);
        return global.kobold.history.getKey(id, boobsId);
    };

    this.lactating = function () {
        var lactatingId = key + separator + "lactating";
        global.kobold.history.setIfNotSet(id, lactatingId, global.kobold.body.lactating);
        return global.kobold.history.getKey(id, lactatingId);
    };

    this.name = function () {
        var nameId = key + separator + "name";
        global.kobold.history.setIfNotSet(id, nameId, global.kobold.name);
        return global.kobold.history.getKey(id, nameId);
    };


    this.health = function () {
        var healthId = key + separator + "health";
        global.kobold.history.setIfNotSet(id, healthId, global.kobold.status.physical.get());
        return global.kobold.history.getKey(id, healthId);
    };

    this.unsetHealth = function () {
        var healthId = key + separator + "health";
        global.kobold.history.unsetKey(id, healthId);
    };

    this.sanity = function () {
        var sanityId = key + separator + "sanity";
        global.kobold.history.setIfNotSet(id, sanityId, global.kobold.status.mental.get());
        return global.kobold.history.getKey(id, sanityId);
    };

    this.unsetSanity = function () {
        var sanityId = key + separator + "sanity";
        global.kobold.history.unsetKey(id, sanityId);
    };

    this.stamina = function () {
        var staminaId = key + separator + "stamina";
        global.kobold.history.setIfNotSet(id, staminaId, global.kobold.status.stamina.get());
        return global.kobold.history.getKey(id, staminaId);
    };

    this.unsetStamina = function () {
        var staminaId = key + separator + "stamina";
        global.kobold.history.unsetKey(id, staminaId);
    };

    this.exertion = function () {
        var exertionId = key + separator + "exertion";
        global.kobold.history.setIfNotSet(id, exertionId, global.kobold.status.exertion.get());
        return global.kobold.history.getKey(id, exertionId);
    };

    this.unsetExertion = function () {
        var exertionId = key + separator + "exertion";
        global.kobold.history.unsetKey(id, exertionId);
    };


    this.agility = function () {
        var agilityId = key + separator + "agility";
        global.kobold.history.setIfNotSet(id, agilityId, global.kobold.stats.get(StatsEnum.AGILITY));
        return global.kobold.history.getKey(id, agilityId);
    };

    this.unsetAgility = function () {
        var agilityId = key + separator + "agility";
        global.kobold.history.unsetKey(id, agilityId);
    };

    this.charisma = function () {
        var charismaId = key + separator + "charisma";
        global.kobold.history.setIfNotSet(id, charismaId, global.kobold.stats.get(StatsEnum.CHARISMA));
        return global.kobold.history.getKey(id, charismaId);
    };

    this.unsetCharisma = function () {
        var charismaId = key + separator + "charisma";
        global.kobold.history.unsetKey(id, charismaId);
    };

    this.endurance = function () {
        var enduranceId = key + separator + "endurance";
        global.kobold.history.setIfNotSet(id, enduranceId, global.kobold.stats.get(StatsEnum.ENDURANCE));
        return global.kobold.history.getKey(id, enduranceId);
    };

    this.unsetEndurance = function () {
        var enduranceId = key + separator + "endurance";
        global.kobold.history.unsetKey(id, enduranceId);
    };

    this.intelligence = function () {
        var intelligenceId = key + separator + "intelligence";
        global.kobold.history.setIfNotSet(id, intelligenceId, global.kobold.stats.get(StatsEnum.INTELLIGENCE));
        return global.kobold.history.getKey(id, intelligenceId);
    };

    this.unsetIntelligence = function () {
        var intelligenceId = key + separator + "intelligence";
        global.kobold.history.unsetKey(id, intelligenceId);
    };

    this.luck = function () {
        var luckId = key + separator + "luck";
        global.kobold.history.setIfNotSet(id, luckId, global.kobold.stats.get(StatsEnum.LUCK));
        return global.kobold.history.getKey(id, luckId);
    };

    this.unsetLuck = function () {
        var luckId = key + separator + "luck";
        global.kobold.history.unsetKey(id, luckId);
    };

    this.strength = function () {
        var strengthId = key + separator + "strength";
        global.kobold.history.setIfNotSet(id, strengthId, global.kobold.stats.get(StatsEnum.STRENGTH));
        return global.kobold.history.getKey(id, strengthId);
    };

    this.unsetStrength = function () {
        var strengthId = key + separator + "strength";
        global.kobold.history.unsetKey(id, strengthId);
    };

    this.unsetAll = function () {
        that.unsetHealth();
        that.unsetSanity();
        that.unsetStamina();
        that.unsetExertion();
        that.unsetAgility();
        that.unsetCharisma();
        that.unsetEndurance();
        that.unsetIntelligence();
        that.unsetLuck();
        that.unsetStrength();
    };
}
